// gridentd    (c) spender 2001 

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <pwd.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <syslog.h>

#define NONROOTUSER "nobody"
#define PROC_TCP "/proc/net/tcp"
#define CONF_FILE "/etc/gridentd.conf"
#define TIMEOUT 30
#define PORT 113

int sock;
char username[64][64];
char policy[64][9];

void config_read(void)
{
	FILE *config;
	char buf[256],*p,*last;
	int i,x;
	config=fopen(CONF_FILE,"r");
	if(!config)
	{
		syslog(LOG_ERR,"Error opening %s for reading.",CONF_FILE);
		exit(1);
	}

	for(x=0;(x < 64) && (!feof(config));x++)
	{
		memset(buf,0,sizeof buf);
		fgets(buf,sizeof buf,config);
		for(i=0,(p=strtok_r(buf,":",&last));p;
		(p=strtok_r(NULL,":",&last)),i++)
		{
			switch(i){
				case 0: strncpy(username[x],p,sizeof(username[x]));
					username[x][sizeof(username[x])-1]='\0';
					break;
				case 1: strncpy(policy[x],p,sizeof(policy[x]));
					if(policy[x][strlen(policy[x])-1]=='\n')
					policy[x][strlen(policy[x])-1]='\0';
					else policy[x][sizeof(policy[x])-1]='\0';
					break;
				}
		}
	}
	fclose(config);
}

int hex_char(char c)
{
	if (c >= '0' && c <= '9') return (c-'0');
	else if (c >= 'A' && c <= 'F') return (c-'A'+0xA);
	else return 0;
}

int hex_to_int(char *str, int cnt)
{
	int i;
	int n=0;
	for (i=0; i<cnt; i++) n = (n<<4) | hex_char(str[i]);
	return n;
}


int get_tcp_info(int l_port, unsigned long r_ip, int r_port)
{
	FILE *tcp;
	char buf[128],uidstr[6];
	int local_port,remote_port,socket_uid,x;
	unsigned long remote_ip;
	tcp = fopen(PROC_TCP, "r");
	if (!tcp)
	{
	    syslog(LOG_ERR,"Error opening %s.  Quitting.",PROC_TCP);
	    exit(1);
	}
	fgets(buf, sizeof buf, tcp);
	while (!feof(tcp))
	{
		fgets(buf, sizeof buf, tcp);
		local_port=hex_to_int(buf+15,4);
		remote_ip=ntohl(hex_to_int(buf+20,8));
		remote_port=hex_to_int(buf+29,4);
		memset(&uidstr,0,sizeof uidstr);
		for(x=76;x<=80;x++)
		{
		    uidstr[x-76]=buf[x];
		}
		uidstr[sizeof uidstr]='\0';
		socket_uid=atoi(uidstr);
		if(local_port == l_port && remote_ip == r_ip && remote_port == r_port)
		{
		    fclose(tcp);
		    return socket_uid;
		}
	}
	fclose(tcp);
	return -1;   /* user not found */
}



void drop_root(void)
{
    if (getuid() == 0 || geteuid() == 0)
    {
	struct passwd *nonroot;
	nonroot = getpwnam(NONROOTUSER);
	if (!nonroot)
	{
	    syslog(LOG_ERR,"Could not drop root privileges from user %s, check to make sure user exists.",NONROOTUSER);
	    exit(1);
	}
	setregid(nonroot->pw_gid, nonroot->pw_gid);
	setreuid(nonroot->pw_uid,nonroot->pw_uid);
    }
}

int do_ident(void)
{
	char req[512], reply[512], randomid[11], *p;
	int pos, cnt;
	fd_set fdset;
	struct timeval tv;
	struct sockaddr_in sin;
	int sinlen = sizeof sin;
	int ip,i,z;
	int l_port, r_port;
	int uid;
	struct passwd *user;
    
	if (getpeername(sock, (struct sockaddr *)&sin, &sinlen) == 0)
		ip = ntohl(sin.sin_addr.s_addr);
	else
		//0x7f000001 is the hex equiv of 127.0.0.1
		ip = 0x7F000001;
	
	pos = 0;
	do
	{
		FD_ZERO(&fdset);
		FD_SET(0, &fdset);
		tv.tv_sec = TIMEOUT;
		tv.tv_usec = 0;
		if (select (1, &fdset, NULL, NULL, &tv) <= 0) return -1;
		cnt = read(0, req+pos, sizeof req - pos - 1);
		if (cnt <= 0) return -1;
		pos += cnt;
		req[pos] = 0;
		if (sizeof req - pos - 1 == 0) return -1;
	} while (!strpbrk(req, "\r\n"));
	p = req;
	printf("%s",req);
	while (*p == ' ') p++;
	l_port = atoi(p);
	p = strchr(p, ',');
	if (!p) return -1;
	p++;
	while (*p == ' ') p++;
	r_port = atoi(p);

	if (l_port < 1 || l_port > 65535 || r_port < 1 || r_port > 65535)
	{
		sprintf(reply, "%d , %d : ERROR : INVALID-PORT\r\n", l_port, r_port);
		write(1, reply, strlen(reply));
		return 0;
	}
	
	uid = get_tcp_info(l_port, ip, r_port);
	printf("%i\n",uid);
	if (uid == -1)
	    sprintf(reply, "%d , %d : ERROR : NO-USER\r\n", l_port, r_port);
	else
	{
	    user = getpwuid(uid);
	    if (!user) sprintf(reply,"%d, %d : USERID : UNIX : %d\r\n",l_port,r_port,uid);
	    else 
	    {
		for(i=0;i<64;i++)
		{
			if((!strcmp(username[i],user->pw_name)) || (!strcmp(username[i],"all")))
			{
				if(!strcmp(policy[i],"stealth"))
				{
					sprintf(reply,"%d , %d : ERROR : NO-USER\r\n",l_port,r_port);
					write(1,reply,strlen(reply));
					return 0;
				}
				else if(!strcmp(policy[i],"drop"))
					return 0;
				else if(!strcmp(policy[i],"random"))
				{
					memset(randomid,0,sizeof(randomid));
					for(z=0;z<sizeof(randomid)-1;z++)
        				{
                				gettimeofday(&tv,0);
                				srandom(tv.tv_usec);
                				if(random()%2)
                					randomid[z]=65+(25.0*random()/(RAND_MAX+1.0));
                				else
                					randomid[z]=97+(25.0*random()/(RAND_MAX+1.0));
					}
					randomid[sizeof(randomid)-1]='\0';
					sprintf(reply,"%d, %d : USERID : UNIX : %.12s\r\n",l_port,r_port,randomid);
					write(1,reply,strlen(reply));
					return 0;
				}
			}
		}		
		sprintf(reply,"%d, %d : USERID : UNIX : %.128s\r\n",l_port,r_port,user->pw_name);
	    }
	}
	write(1, reply, strlen(reply));
	return 0;
}

int main(void)
{ 	
    config_read();
    drop_root();
    do_ident();
    close(0);
    close(1);
    return 0;
}

